program interpmatrix
implicit none
character         :: fname*100
character(8)      :: dummy1,dummy2
real              :: st1,st2,inc1,inc2
integer           :: row,col
integer           :: i,j,k,k2,k4
real,allocatable  :: densmd(:,:)
!--------------------------------------------
write(*,*) 'Enter grid data file name: '
read (*,'(a)') fname
open (1,err=90,file='c'//fname,status='old')
read (1,'(a)') fname
read (1,*) col,row,st1,st2,inc1,inc2
read (1,*) dummy1,dummy2
allocate (densmd(row,col))
write (*,*) 'reading data'
do j=1,row
 read(1,*) (densmd(j,i),i=1,col)
enddo          
close(1)
write(*,*) 'interpolatig matrix'
!corners
if (densmd(1,1)==-1) then;   do i=1,col-1 
      if (densmd(1+i,i).ne.-1) then; densmd(1,1)=densmd(1+i,i);   exit
      elseif (densmd(1,i+1).ne. -1) then ; densmd(1,1)=densmd(1,i+1) ; exit;  endif
enddo; endif
if (densmd(1,col)==-1) then;   do i=1,col-1
   if (densmd(1+i,col).ne.-1) then; densmd(1,col)=densmd(1+i,col); exit
   elseif (densmd(1,col-i).ne. -1) then;  densmd(1,col)=densmd(1,col-i); exit; endif
enddo; endif
if (densmd(row ,1)==-1) then;   do i=1,col-1
  if (densmd(row -i,1).ne.-1) then; densmd(row ,1)=densmd(row -i,1) ;   exit
  elseif (densmd(row ,i+1).ne.-1) then; densmd(row ,1)=densmd(row ,i+1) ; exit; endif
enddo; endif
if (densmd(row ,col)==-1) then ;   do i=1,col-1
  if (densmd(row -i,col).ne.-1) then; densmd(row ,col)=densmd(row -i,col); exit
  elseif (densmd(row ,col-i).ne. -1)then; densmd(row ,col)=densmd(row ,col-i) ; exit; endif
enddo; endif


!filling first row
do i=1,col-1 ;   if (densmd(1,i) == -1) then
  do k=1,col-i ;  if (densmd(1,i+k).ne.-1)  exit;  enddo
  densmd(1,i)=(densmd(1,i-1)+(densmd(1,i+k)/k))/(1.+(1./k)) 
endif; enddo
!filling last row
do i=1,col-1 ;   if (densmd(row ,i) == -1) then
  do k=1,col-i; if (densmd(row ,i+k).ne. -1) exit;  enddo
  densmd(row ,i)=(densmd(row ,i-1)+(densmd(row ,i+k)/k))/(1.+(1./k))
endif
 enddo

!filling first column
do i=1,row-1;   if (densmd(i,1) == -1) then
   do k=1,row-i;  if (densmd(i+k,1).ne. -1) exit;    enddo
   densmd(i,1)=(densmd(i-1,1)+(densmd(i+k,1)/k))/(1.+(1./k))
endif
 enddo
!filling last column
do i=1,row-1;   if (densmd(i,col) == -1) then
  do k=1,row-i;  if (densmd(i+k,col).ne. -1) exit;    enddo
  densmd(i,col)=(densmd(i-1,col)+(densmd(i+k,col)/k))/(1.+(1./k))
endif; enddo

!filling center
do i = 2,col-1;  do j = 2,row-1 ;  if (densmd(j,i) == -1) then
    do k=1,row-1-j+1; if (densmd(j+k,i).ne. -1) then;  k2=k; exit;  endif;      enddo
    do k=1,col-i; if (densmd(j,i+k).ne.-1) then; k4=k;  exit;  endif;    enddo
    densmd(j,i)=densmd(j-1,i)+(densmd(j+k2,i)/k2)+densmd(j,i-1)+(densmd(j,i+k4)/k4)
    densmd(j,i)=densmd(j,i)/(2.+(1./k2)+(1./k4))
endif; enddo;enddo

open(2,file='intmap')
do j=1,row
 write(2,'(1000(e14.6))') (densmd(j,i),i=1,col)
enddo
close(2)

write (*,*) 'writing interpolated grid data to file i'//fname
open (3,file='i'//fname)
write (3,*) fname
write (3,*) col,row,st1,st2,inc1,inc2
write (3,*) dummy1,dummy2
do j=1,row
 write(3,'(1000(e14.6))') (densmd(j,i),i=1,col)
enddo

goto 2000
90    write (*,1060) fname
1060  format (/,' No such file as: ',a14,/)

2000 end
